From 82a3ae1cb14dd0661e05894934a39b6d403e7650 Mon Sep 17 00:00:00 2001
From: Daan De Meyer <daan.j.demeyer@gmail.com>
Date: Jan 20 2022 16:52:29 +0000
Subject: [PATCH 8/15] journal: Introduce EntryItemEx


In later commits, we need to attach extra information to EntryItem.
To allow doing so, introduce a new struct EntryItemEx that we can
safely modify without modifying the journal format. We'll add more
fields to EntryItemEx in later commits.

---

diff --git a/src/libsystemd/sd-journal/journal-def.h b/src/libsystemd/sd-journal/journal-def.h
index 07df844..75c7a5e 100644
--- a/src/libsystemd/sd-journal/journal-def.h
+++ b/src/libsystemd/sd-journal/journal-def.h
@@ -91,6 +91,12 @@ struct EntryItem {
         le64_t hash;
 } _packed_;
 
+/* Extended version of EntryItem that stores extra information that we don't store in the journal file. */
+typedef struct {
+        uint64_t object_offset;
+        uint64_t hash;
+} EntryItemEx;
+
 #define EntryObject__contents { \
         ObjectHeader object;    \
         le64_t seqnum;          \
diff --git a/src/libsystemd/sd-journal/journal-file.c b/src/libsystemd/sd-journal/journal-file.c
index 3cacac3..691402f 100644
--- a/src/libsystemd/sd-journal/journal-file.c
+++ b/src/libsystemd/sd-journal/journal-file.c
@@ -1778,15 +1778,13 @@ static int link_entry_into_array_plus_one(JournalFile *f,
         return 0;
 }
 
-static int journal_file_link_entry_item(JournalFile *f, Object *o, uint64_t offset, uint64_t i) {
-        uint64_t p;
+static int journal_file_link_entry_item(JournalFile *f, Object *o, uint64_t offset, uint64_t p) {
         int r;
 
         assert(f);
         assert(o);
         assert(offset > 0);
 
-        p = le64toh(o->entry.items[i].object_offset);
         r = journal_file_move_to_object(f, OBJECT_DATA, p, &o);
         if (r < 0)
                 return r;
@@ -1798,8 +1796,8 @@ static int journal_file_link_entry_item(JournalFile *f, Object *o, uint64_t offs
                                               offset);
 }
 
-static int journal_file_link_entry(JournalFile *f, Object *o, uint64_t offset) {
-        uint64_t n;
+static int journal_file_link_entry(
+                JournalFile *f, Object *o, uint64_t offset, const EntryItemEx items[], size_t n_items) {
         int r;
 
         assert(f);
@@ -1829,9 +1827,8 @@ static int journal_file_link_entry(JournalFile *f, Object *o, uint64_t offset) {
         f->header->tail_entry_monotonic = o->entry.monotonic;
 
         /* Link up the items */
-        n = journal_file_entry_n_items(o);
-        for (uint64_t i = 0; i < n; i++) {
-                r = journal_file_link_entry_item(f, o, offset, i);
+        for (uint64_t i = 0; i < n_items; i++) {
+                r = journal_file_link_entry_item(f, o, offset, items[i].object_offset);
                 if (r < 0)
                         return r;
         }
@@ -1844,7 +1841,7 @@ static int journal_file_append_entry_internal(
                 const dual_timestamp *ts,
                 const sd_id128_t *boot_id,
                 uint64_t xor_hash,
-                const EntryItem items[], unsigned n_items,
+                const EntryItemEx items[], size_t n_items,
                 uint64_t *seqnum,
                 Object **ret, uint64_t *ret_offset) {
         uint64_t np;
@@ -1864,7 +1861,9 @@ static int journal_file_append_entry_internal(
                 return r;
 
         o->entry.seqnum = htole64(journal_file_entry_seqnum(f, seqnum));
-        memcpy_safe(o->entry.items, items, n_items * sizeof(EntryItem));
+        for (size_t i = 0; i < n_items; i++)
+                o->entry.items[i] = (EntryItem){ .object_offset = htole64(items[i].object_offset),
+                                                 .hash = htole64(items[i].hash) };
         o->entry.realtime = htole64(ts->realtime);
         o->entry.monotonic = htole64(ts->monotonic);
         o->entry.xor_hash = htole64(xor_hash);
@@ -1878,7 +1877,7 @@ static int journal_file_append_entry_internal(
                 return r;
 #endif
 
-        r = journal_file_link_entry(f, o, np);
+        r = journal_file_link_entry(f, o, np, items, n_items);
         if (r < 0)
                 return r;
 
@@ -1973,13 +1972,11 @@ int journal_file_enable_post_change_timer(JournalFile *f, sd_event *e, usec_t t)
         return r;
 }
 
-static int entry_item_cmp(const EntryItem *a, const EntryItem *b) {
-        return CMP(le64toh(a->object_offset), le64toh(b->object_offset));
+static int entry_item_cmp(const EntryItemEx *a, const EntryItemEx *b) {
+        return CMP(a->object_offset, b->object_offset);
 }
 
-static size_t remove_duplicate_entry_items(EntryItem items[], size_t n) {
-
-        /* This function relies on the items array being sorted. */
+static size_t remove_duplicate_entry_items(EntryItemEx items[], size_t n) {
         size_t j = 1;
 
         if (n <= 1)
@@ -2000,7 +1997,7 @@ int journal_file_append_entry(
                 uint64_t *seqnum,
                 Object **ret, uint64_t *ret_offset) {
 
-        EntryItem *items;
+        EntryItemEx *items;
         int r;
         uint64_t xor_hash = 0;
         struct dual_timestamp _ts;
@@ -2029,7 +2026,7 @@ int journal_file_append_entry(
                 return r;
 #endif
 
-        items = newa(EntryItem, n_iovec);
+        items = newa(EntryItemEx, n_iovec);
 
         for (size_t i = 0; i < n_iovec; i++) {
                 uint64_t p;
@@ -2053,9 +2050,9 @@ int journal_file_append_entry(
                 else
                         xor_hash ^= le64toh(o->data.hash);
 
-                items[i] = (EntryItem) {
-                        .object_offset = htole64(p),
-                        .hash = o->data.hash,
+                items[i] = (EntryItemEx) {
+                        .object_offset = p,
+                        .hash = le64toh(o->data.hash),
                 };
         }
 
@@ -3593,7 +3590,7 @@ int journal_file_copy_entry(JournalFile *from, JournalFile *to, Object *o, uint6
         uint64_t q, n, xor_hash = 0;
         const sd_id128_t *boot_id;
         dual_timestamp ts;
-        EntryItem *items;
+        EntryItemEx *items;
         int r;
 
         assert(from);
@@ -3611,7 +3608,7 @@ int journal_file_copy_entry(JournalFile *from, JournalFile *to, Object *o, uint6
         boot_id = &o->entry.boot_id;
 
         n = journal_file_entry_n_items(o);
-        items = newa(EntryItem, n);
+        items = newa(EntryItemEx, n);
 
         for (uint64_t i = 0; i < n; i++) {
                 uint64_t l, h;
@@ -3668,9 +3665,9 @@ int journal_file_copy_entry(JournalFile *from, JournalFile *to, Object *o, uint6
                 else
                         xor_hash ^= le64toh(u->data.hash);
 
-                items[i] = (EntryItem) {
-                        .object_offset = htole64(h),
-                        .hash = u->data.hash,
+                items[i] = (EntryItemEx) {
+                        .object_offset = h,
+                        .hash = le64toh(u->data.hash),
                 };
 
                 r = journal_file_move_to_object(from, OBJECT_ENTRY, p, &o);

